//*******************************************************************************************
// Spiel: Warship Adventure
//-------------------------------------------------------------------------------------------
// Version:    1.0
// Copyright:  Samuel Burgener, Aloïs Guntern, Janes Höppner, Fabian Fuchs
//*******************************************************************************************
//Soundbibliothek importieren
import processing.sound.*;

//-------------------------------------------------------------------------------------------
// Gloable Variablen
//-------------------------------------------------------------------------------------------
// Klasse für Bilder: PImage 
PImage bg;                                  // Hintergrund, grossflächig
PImage pfeil_links;                         //Pfeil für Anleitung laden
PImage pfeil_rechts;                        //Pfeil für Anleitung laden
PImage start;                               // Bild Startseite
PImage schiff;                              // Das Schiff
PImage water_ripple;                        // Wellen rund um das Schiff
PImage stein;                               // Steine im Wasser
PImage bg_clory;                            // Hintergrund Highscore
PImage podium;                              // Podium
int score = 0;                              // Score
int[] highscore = new int[3];               // Array für Highscore Tabelle 
int xPosSchiff = 270;                       // X Position des Schiffes
int yPosSchiff = 420;                       // Y Position des Schiffes
int yPosBg = 0;                             // y Position des Hintergrunds
int hintergrundLetzteBewegung = 0;          // Zeitpunkt der letzten Bewegung
int hintergrundGeschwindigkeit = 1;         // Geschwindigkeit des Hintergrunds
int phase = 0;                              // Die Phasen des Spiels
int startSpiel = 0;                         // Startzeit des Spiels
int anzahlSteine = 6;                       // Anzahl Steine im Wasser
int[] xPosStein = new int[anzahlSteine];    // X Position der Steine
int[] yPosStein = new int[anzahlSteine];    // Y Position der Steine
int[] radiusStein = new int[anzahlSteine];  // Grösse (Radius) des Steins
int steinLetzteBewegung = 0;                // Zeitpunkt der letzten Bewegung 
int steinGeschwindigkeit = 1;               // Bewegung in y Richtung
boolean schiffKollision = false;            // Kollision 
                                                  
                                            
//Musik benennen
SoundFile Hintergrundmusik;
SoundFile Spielmusik;
SoundFile GameOver;

//*******************************************************************************************
// Setup()
//-------------------------------------------------------------------------------------------
// Initalisierung am Anfang des Programmes. Wird einmal ausgeführt
//*******************************************************************************************
void setup(){
  // Bildschrim 
  size(540,700);
  frameRate(200);
  // startup anzeigen
  start = loadImage("Hintergrund Startbildschirm3.jpg");
  start.resize(width,height);              // Hintergrund auf Bildschirm Grösse anpassen
  startup();
  //Bilder einladen
  pfeil_links = loadImage("Pfeil links.png");
  pfeil_rechts = loadImage("Pfeil rechts.png");
  schiff = loadImage("Schiff.png");
  bg = loadImage("Hintergrund.jpg");
  bg.resize(width,height);              // Hintergrund auf Bildschirm Grösse anpassen
  bg_clory = loadImage("bg_clory.jpg");
  bg_clory.resize(width,height);
  water_ripple = loadImage("water_ripple_big_000.png");
  stein = loadImage("Stein_untenrund.png");
  podium = loadImage("podium.png");                                            
}

//*******************************************************************************************
// draw()
//-------------------------------------------------------------------------------------------
// Hauptfunktion, wird ausgeführt bis das Programm gestoppt wird
//*******************************************************************************************
void draw(){
  if(phase == 0){
    // Initialisierung. Das Laden der Audio Dateien braucht Zeit
    Hintergrundmusik = new SoundFile(this, "Heart-Of-The-Ocean.mp3");
    Spielmusik = new SoundFile (this, "Spielmusik.mp3");
    GameOver = new SoundFile (this, "GameOver.wav");
    phase = 1;
  } else if(phase == 1) {
    //Startbildschirm generieren 
    showStartScreen();
    playHintergrundmusik();
    phase = 2;
  } else if (phase == 2 ) {
    // Warten auf Eingabe von Start Bildschirm
    if(mousePressed  && mouseButton == LEFT) {
      if(mouseX >= 100 && mouseX <= 250 && mouseY >= 240 && mouseY <= 315) {
        // Anleitung
        phase = 20;
      }
      else if(mouseX >= 300 && mouseX <= 450 && mouseY >= 240 && mouseY <= 315) {
        // Spielen
        initTheGame();
        Hintergrundmusik.stop();
        playSpielmusik();
        phase = 30;
      } 
      else if(mouseX >= 200 && mouseX <= 350 && mouseY >= 340 && mouseY <= 415) {
        // Highscore
        phase = 40;
      } 
      delay(200);
    } 
  } else if (phase == 20 ) {
      // Anleitung anzeigen
      showManual();
      phase = 21;
  } else if (phase == 21 ) {
      // Warten auf Eingabe von Anleitung Bildschirm
      if(mousePressed && mouseButton == LEFT) {
        if(mouseX >= width/2-100 && mouseX <= width/2 + 100 && mouseY >= 260 && mouseY <= 360 ) {
          phase = 1;        
        }
      }
  } else if (phase == 30 ) {
      // Das Spiel spielen 
      playTheGame();
      // Spielen bis Kollision
      if (schiffKollision == true ) {
        phase = 31;
        playGameOver();
        // Score dazufügen
        if(score > min(highscore)) {
          // Top 3 Resultat 
          if(score > highscore[0]) {
            highscore[2] = highscore[1];
            highscore[1] = highscore[0];
            highscore[0] = score;
          } else if (score > highscore[1]) {
            highscore[2] = highscore[1];
            highscore[1] = score;
          } else {
            highscore[2] = score;
          }
        }
      }
  }  else if (phase == 31 ) {
      // Game over
      fill(255);
      textSize(80);
      textAlign(CENTER);
      text("Game over",width/2,200);
      noStroke();
      fill(#9E9EB2);
      rect(85, 335, 180, 75);
      rect(305, 335, 180, 75);
      fill(0);
      textSize(30);
      text("Spielen",175,380);
      text("Hauptmenü",395,380);
      Spielmusik.stop();
      //Möglichkeit zum Hauptmenü oder ernbeut spielen zu gelangen
      if(mousePressed  && mouseButton == LEFT) {
        if(mouseX >= 305 && mouseX <= 485 && mouseY >= 335 && mouseY <= 410) {
          // Hauptmenü
          phase = 1;
        }
        if(mouseX >= 85 && mouseX <= 265 && mouseY >= 335 && mouseY <= 410) {
          // SPielen
          initTheGame();
          Hintergrundmusik.stop();
          playSpielmusik();
          phase = 30;   
        }
      }
  }
  else if (phase == 40 ) {
      // Highscore anzeigen
      showHighscore();
      phase = 41;
  } else if (phase == 41 ) {
      // Warten auf für zurück
      if(mousePressed && mouseButton == LEFT) {
        if(mouseX >= width/2-100 && mouseX <= width/2 + 100 && mouseY >= 560 && mouseY <= 640 ) {
          phase = 1;        
        }
      }
  }
}

//*******************************************************************************************
// startup()
//-------------------------------------------------------------------------------------------
// Bitte warten bis alles geladen ist
//*******************************************************************************************
void startup() {
  background(start);
  fill(0);
  textSize(80);
  textAlign(CENTER);
  text("Warship",width/2,100);
  text("Adventure", width/2, 170);
  textSize(30);
  text("Das Spiel wird geladen",width/2,220);
  text("Bitte warten...",width/2,250);
}

//*******************************************************************************************
// showStartScreen()
//-------------------------------------------------------------------------------------------
// Zeigt den Start Bildschirm an
//*******************************************************************************************
void showStartScreen() {
  // Hintergrund setzen und text darstellen
  background(start);
  fill(0);
  textSize(80);
  textAlign(CENTER);
  text("Warship",width/2,100);
  text("Adventure", width/2, 170);
  fill(#9E9EB2);
  //Knöpfe erstellen
  noStroke();
  rect(100, 240, 150, 75);
  rect(290, 240, 150, 75);
  rect(200, 340, 150, 75);
  fill(0);
  textSize(30);
  text("Anleitung",175,285);
  text("Spielen",365,285);
  text("Highscore",275,385);
}

//*******************************************************************************************
// showManual()
//-------------------------------------------------------------------------------------------
// Anleitung anzeigen
//*******************************************************************************************
void showManual() {
  //Die Anleitung anzeigen
  image(bg,0,0, 540,960);
  image(schiff, 210, 400);
  image(pfeil_rechts, 340,550,50,50);
  image(pfeil_links, 150,550,50,50);
  textAlign(CENTER);
  fill(255);
  textSize(30);
  text("Die Anleitung",width/2,100);
  textSize(20);
  text("Bewege dich mit den Pfeiltasten hin und her," ,width/2, 150);
  text("sodass du nicht von den Steinen getroffen wirst.",width/2, 190);
  text("Die Steine werden immer schneller, also pass gut auf!", width/2, 230);
  //Knopf zeichnen
  rectMode(CENTER);
  fill(#9E9EB2);
  rect(width/2, 310, 200,100);
  fill(0);
  textSize(30);
  textAlign(CENTER);
  text("Hauptmenü", width/2, 320);
  rectMode(CORNER);
}

//*******************************************************************************************
// playHintergrundmusik()
//-------------------------------------------------------------------------------------------
// Musik abspielen
//*************************************************************************************
void playHintergrundmusik() {
  Hintergrundmusik.play();
}

//*******************************************************************************************
// playSpielmusik()
//-------------------------------------------------------------------------------------------
// Musik abspielen
//*************************************************************************************
void playSpielmusik() {
  Spielmusik.play();
}

//*******************************************************************************************
// playGameOver()
//-------------------------------------------------------------------------------------------
// Musik abspielen
//*************************************************************************************
void playGameOver() {
  GameOver.play();
}

//*******************************************************************************************
// showHighscore()
//-------------------------------------------------------------------------------------------
// Die besten 3 Resulate anzeigen
//*******************************************************************************************
void showHighscore() {
  int platz = -1;
  //Das Podest anzeigen
  background(bg_clory);
  image(podium,20,250,width-40,200);
  textAlign(CENTER);
  textSize(80);
  text("Das Podest",width/2,100);
  textSize(40);
  text(highscore[0], 265, 250);
  text(highscore[1], 140, 300);
  text(highscore[2], 390, 315);
  // Platzierung bestimmen
  for(int i = 0; i < 3; i++) {
    if(score == highscore[i]) {
      platz = i;
    }
  }
  if(platz == -1) {
    text("Leider kein Podestplatz für dich",width/2,180);
  } else if(platz == 0) { 
    text("Gratulation zum 1. Platz",width/2,180);
  } else if(platz == 1) {
    text("Gratulation zum 2. Platz",width/2,180);
  } else if(platz == 2) {
    text("Gratulation zum 3. Platz",width/2,180);
  }
  textAlign(RIGHT);
  text("Dein Score:  ",width/2,480);
  textAlign(LEFT);
  text(score,width/2,480);
  textAlign(CENTER);
  //Knopf zeichnen
  rectMode(CENTER);
  fill(#9E9EB2);
  rect(width/2, 600, 200,80);
  fill(0);
  textSize(30);
  textAlign(CENTER);
  text("Hauptmenü", width/2, 610);
  rectMode(CORNER);
}

//*******************************************************************************************
// initTheGame()
//-------------------------------------------------------------------------------------------
// Das Spiel inizialisieren
//*******************************************************************************************
void initTheGame() {
  // Variablen zurücksetzen
  steinGeschwindigkeit = 1;
  startSpiel = millis();
  schiffKollision = false;
  // Bilder anzeigen
  background(bg);
  image(water_ripple, xPosSchiff-25,yPosSchiff,150,250);
  image(schiff, xPosSchiff, yPosSchiff, 100, 235);
  //Schiff mit geometrischen Formen festlegen. Wird für die Kollisionsdetektion verwendet
  //Nur zum Testen, sonst als Kommentar
  // noFill();
  // triangle(xPosSchiff+18,yPosSchiff+70,xPosSchiff+50,yPosSchiff+5,xPosSchiff+82, yPosSchiff+70);
  // rect(xPosSchiff+18, yPosSchiff+70, 64, 155);
  // Steine verteilen
  for (int i = 0; i < anzahlSteine; i = i+1) {
    xPosStein[i] = int(random(0,width));
    yPosStein[i] = int(random(-200,yPosSchiff-200));
    radiusStein[i] = int(random(50,100));
    image(stein,xPosStein[i],yPosStein[i],radiusStein[i],radiusStein[i]);
  } 
  steinLetzteBewegung = millis();
}


//*******************************************************************************************
// playTheGame()
//-------------------------------------------------------------------------------------------
// Das Spiel spielen
//*******************************************************************************************
void playTheGame() {
  // Bewegung Schiff wenn Taste gedrückt
            
  int xPosStep = 1;
  // Bilder anzeigen
 // hintergrundAnzeigen();
   image(bg, 0,0,width, height);
  steineAnzeigen();
  image(water_ripple, xPosSchiff-25,yPosSchiff,150,250);
  image(schiff, xPosSchiff, yPosSchiff, 100, 235);
  // Kollision anzeigen
  shiffKollision();
  //Score anzeigen
  score = (int)((millis()-startSpiel)/1000);
  textSize(50);
  fill(255);
  text("Score:",300,50);
  text(score,480,50);
  fill(0);
  //umso höher der Score umso schneller das Schiff
  if (score<=20){
      xPosStep = 1;
  } else if (score<=40) {
      xPosStep = 2;
  } else {
    xPosStep = 3; 
  }
  //Tasten auswerten, Schiff bewegen
  if(keyPressed){
    if (key == CODED){
      if (keyCode == LEFT && xPosSchiff >0){
           xPosSchiff=xPosSchiff - xPosStep;
      }
      if (keyCode == RIGHT && xPosSchiff <width-100){
          xPosSchiff=xPosSchiff + xPosStep;
      }
    }
  }
}


//*******************************************************************************************
// steineAnzeigen()
//-------------------------------------------------------------------------------------------
// Steine bewegen und anzeigen
//*******************************************************************************************
void steineAnzeigen() {
  // Steine alle 100 Millisekunden bewegen
  if (  millis() - steinLetzteBewegung > 100 ) {
    steinLetzteBewegung = millis();
    // Alle 3 Sekunden tempo erhöhen (Formel = Zinsenszins
    steinGeschwindigkeit = int(1*pow((1+0.30),int((millis()-startSpiel)/3000)));
    // Steine nur nach unten bewegen, X Position bleibt gleich
    for (int i = 0; i < anzahlSteine; i = i+1) {
       yPosStein[i] =  yPosStein[i] + steinGeschwindigkeit;
       // Falls ein Stein unten raus verschwunden ist ein neuer Einfügen
       if( (yPosStein[i] + radiusStein[i]/2) > height) {
         radiusStein[i] = int(random(50,100));
         xPosStein[i] = int(random(0,width));
         yPosStein[i] = - radiusStein[i]/2;
       }
    } 
  }
  // Steine anzeigen
  for (int i = 0; i < anzahlSteine; i = i+1) {
    image(stein,xPosStein[i],yPosStein[i],radiusStein[i],radiusStein[i]);
  }
}

//*******************************************************************************************
// scchiffKollision()
//-------------------------------------------------------------------------------------------
// Kollision berechnen
//*******************************************************************************************
void shiffKollision(){
  // Brechne ob Schiff kollidiert hat Bug = Dreieck
  // Geometrische Fomen -> nur während Entwicklung anzeigen
  // Nur zum Testen, sonst als Kommentar
  // noFill();
  // strokeWeight(4);
  // stroke(#fec106);
  // triangle(xPosSchiff+18,yPosSchiff+70,xPosSchiff+50,yPosSchiff+5,xPosSchiff+82, yPosSchiff+70);
  // rect(xPosSchiff+18, yPosSchiff+70, 64, 155);
  
  // Wir gehen vom guten aus
  schiffKollision = false;    
  // Für alle Punkte brechnen
  for (int i = 0; i < anzahlSteine; i = i+1) {
    if(IsInsideDreieck(xPosStein[i] +radiusStein[i] / 2 , yPosStein[i] + radiusStein[i]/2, radiusStein[i]/2) ||
       IsInsideViereck(xPosStein[i] +radiusStein[i] / 2 , yPosStein[i] + radiusStein[i]/2, radiusStein[i]/2)) {
      // Bei Kollision Stein anzeigen
      schiffKollision = true;
      noFill();
      stroke(#ed225d);
      strokeWeight(8);
      circle(xPosStein[i] +radiusStein[i] / 2 , yPosStein[i] + radiusStein[i]/2, radiusStein[i]);
    }
  }
}

//*******************************************************************************************
// IsInsideDreieck(int pX, int pY, int radius)
//-------------------------------------------------------------------------------------------
// Diese Methode gibt true zurück, wenn der Punkt das Dreieck berührt
// Siehe Breechnung separates Blatt
//*******************************************************************************************
boolean IsInsideDreieck(int pX, int pY, int radius) {
  boolean isInside = false;
  // Dreieck des Buges
  // Breehcnung siehe separates Blatt
  int[] xDreieck = {xPosSchiff+18,xPosSchiff+50,xPosSchiff+82};
  int[] yDreieck = {yPosSchiff+70,yPosSchiff+5,yPosSchiff+70};
  // Eckpunkte überprüfen
  for (int i = 0; i < 3; i++) {
    if(sqrt((pX - xDreieck[i])*(pX - xDreieck[i]) + (pY - yDreieck[i])*(pY - yDreieck[i])) < radius) {
      isInside = true;
    }
  }
  
  // Ausstehend: Kollision mit Seiten des Dreiecks werden nicht geprüft
  return isInside;
}

//*******************************************************************************************
// IsInsideViereck(int pX, int pY, int radius)
//-------------------------------------------------------------------------------------------
// Diese Methode gibt true zurück, wenn der Punkt das viereck berührt
// Siehe Breechnung separates Blatt
//*******************************************************************************************
boolean IsInsideViereck(int pX, int pY, int radius) {
  boolean isInside = false;
  // Viereck des Schiffes
  // Berechnung siehe separates Blatt
  int[] xViereck = {xPosSchiff+18,xPosSchiff+18+64,xPosSchiff+18+64,xPosSchiff+18};
  int[] yViereck = {yPosSchiff+70,yPosSchiff+70,yPosSchiff+70+155,yPosSchiff+70+155};
  // Eckpunkte überprüfen
  for (int i = 0; i < 4; i++) {
    if(sqrt((pX - xViereck[i])*(pX - xViereck[i]) + (pY - yViereck[i])*(pY - yViereck[i])) < radius) {
      isInside = true;
    }
  }
  // Rechteck prüfen horizontal
  if((pY > yPosSchiff+70 && pY < yPosSchiff+70+155 ) && (pX > xPosSchiff+18-radius && pX < xPosSchiff+18+64+radius )) {
    isInside = true;
  }
  // Rechteck prüfen vertikal
  if((pY > yPosSchiff+70-radius && pY < yPosSchiff+70+155+radius ) && (pX > xPosSchiff+18 && pX < xPosSchiff+18+64 )) {
    isInside = true;
  }
  return isInside;
}
